/*-----------------------------------------------------------------------

File  : che_heuristic_parms.h

Author: Stephan Schulz

Contents
 
  Collection of parameters for heuristics and proofcontrol.

Changes

<1> Mon Jun  8 02:14:51 MET DST 1998
    New
<2> Wed Dec 16 18:46:35 MET 1998
    Salvaged from che_heuristics.h

-----------------------------------------------------------------------*/

#ifndef CHE_HEURISTIC_PARMSS

#define CHE_HEURISTIC_PARMSS

#include <che_to_weightgen.h>
#include <che_to_precgen.h>


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/


typedef struct heuristic_parms_cell
{
   char              *heuristic_name;
   PStack_p          wfcb_definitions;
   PStack_p          heuristic_definitions;
   TermOrdering      ordertype;
   TOWeightGenMethod to_weight_gen;
   TOPrecGenMethod   to_prec_gen;
   long              to_const_weight;
   bool              use_indexing;
   RewriteLevel      forward_demod;
   bool              prefer_initial_clauses;
   bool              paramod_with_units_only;
   PStack_p          i_parms;
   DStack_p          d_parms;
   PStack_p          s_parms;
}HeuristicParmsCell, *HeuristicParms_p;

/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/


#define HeuristicParmsCellAlloc() \
   (HeuristicParmsCell*)SizeMalloc(sizeof(HeuristicParmsCell))
#define HeuristicParmsCellFree(junk) \
   SizeFree(junk, sizeof(HeuristicParmsCell))

HeuristicParms_p HeuristicParmsAlloc();
void             HeuristicParmsFree(HeuristicParms_p junk);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





