#!/usr/local/dist/bin/gawk -f

# Usage: find_optimal.awk <class_file1> ... <class_filen>
#
#   Given a set of class files, find the best protokoll* files for
#   each class file.
#
# Copyright 1999 Stephan Schulz, schulz@informatik.tu-muenchen.de

function max(a,b)
{
  if(a>b)
    {
      return a;
    }
  return b;
}


function get_performance(class_file, protokoll,   pipe2, res)
{
   pipe2 = "cat " class_file "|filter_results.awk - " protokoll "|eauswert.awk";
   pipe2 | getline res;
   close(pipe2);
   
   match(res, /[0-9]+/);
   class_total = max(class_total, substr(res, RSTART, RLENGTH)+0);

   match(res, /S\/F\/N\/B:/);
   res = substr(res, RSTART+8);
   match(res, /[0-9]+/);
   res = substr(res, RSTART, RLENGTH);
   return res+0;
}

function find_optimal(class_file,   pipe, protocol, i, max, entry,
		      perf, prot_number)
{
   max = 0;
   entry = 0;
   prot_number = 0;
   
   class_total = 0;

   protocols[0] = "";
   delete protocols;

   # We need to work around some strange gawk/Solaris-bug here...or
   # perhaps only around my own stupidity....

   pipe = "ls protokoll*";
   while((pipe | getline protocol)>0)
   {      
      protocols[prot_number++] = protocol;
   }
   close(pipe);
   
   for(i=0; i< prot_number; i++)
   {      
      perf = get_performance(class_file, protocols[i])+0;
      if(perf > max)
      {
	 candidates[0] = "";
	 delete candidates;
	 entry = 0;
      }
      if(perf >= max)
      {
	 candidates[entry++] = protocols[i];
	 max = perf;
      }	 
   }
   if(entry)
   {
      print class_file " (" max "/" class_total ")";
      if(max>0)
      {
	 for(i=0; i<entry; i++)
	 {
	    print "  " candidates[i] ": " max;
	 }
      }
   }
   return max;
}


BEGIN{
   if(!ARGV[1])
   {
      print "Usage: find_optimal.awk <class_file1> ... <class_filen>";
      exit 1;
   }
   total = 0;
   for(i=1; ARGV[i]; i++)
   {
      current = find_optimal(ARGV[i]);
      total += current;
   }
   print "Total: " total;
}





